﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace TestProject;

/// <summary>
/// 패스 아이콘 버튼
/// </summary>
public partial class PathIconButton : Button
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Dependency Property
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region 마우스 오버 브러시 속성 - MouseOverBrushProperty

    /// <summary>
    /// 마우스 오버 브러시 속성
    /// </summary>
    public static readonly DependencyProperty MouseOverBrushProperty = DependencyProperty.Register
    (
        nameof(MouseOverBrush),
        typeof(Brush),
        typeof(PathIconButton),
        new PropertyMetadata(null)
    );

    #endregion
    #region 프레스 브러시 속성 - PressedBrushProperty

    /// <summary>
    /// 프레스 브러시 속성
    /// </summary>
    public static readonly DependencyProperty PressedBrushProperty = DependencyProperty.Register
    (
        nameof(PressedBrush),
        typeof(Brush),
        typeof(PathIconButton),
        new PropertyMetadata(null)
    );

    #endregion
    #region 패스 너비 속성 - PathWidthProperty

    /// <summary>
    /// 패스 너비 속성
    /// </summary>
    public static readonly DependencyProperty PathWidthProperty = DependencyProperty.Register
    (
        nameof(PathWidth),
        typeof(double),
        typeof(PathIconButton),
        new PropertyMetadata(16d)
    );

    #endregion
    #region 패스 높이 속성 - PathHeightProperty

    /// <summary>
    /// 패스 높이 속성
    /// </summary>
    public static readonly DependencyProperty PathHeightProperty = DependencyProperty.Register
    (
        nameof(PathHeight),
        typeof(double),
        typeof(PathIconButton),
        new PropertyMetadata(16d)
    );

    #endregion
    #region 패스 데이터 속성 - PathDataProperty

    /// <summary>
    /// 패스 데이터 속성
    /// </summary>
    public static readonly DependencyProperty PathDataProperty = DependencyProperty.Register
    (
        nameof(PathData),
        typeof(Geometry),
        typeof(PathIconButton),
        new PropertyMetadata(null)
    );

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 마우스 오버 브러시 - MouseOverBrush

    /// <summary>
    /// 마우스 오버 브러시
    /// </summary>
    public Brush MouseOverBrush
    {
        get
        {
            return (Brush)GetValue(MouseOverBrushProperty);
        }
        set
        {
            SetValue(MouseOverBrushProperty, value);
        }
    }

    #endregion
    #region 프레스 브러시 - PressedBrush

    /// <summary>
    /// 프레스 브러시
    /// </summary>
    public Brush PressedBrush
    {
        get
        {
            return (Brush)GetValue(PressedBrushProperty);
        }
        set
        {
            SetValue(PressedBrushProperty, value);
        }
    }

    #endregion
    #region 패스 너비 - PathWidth

    /// <summary>
    /// 패스 너비
    /// </summary>
    public double PathWidth
    {
        get
        {
            return (double)GetValue(PathWidthProperty);
        }
        set
        {
            SetValue(PathWidthProperty, value);
        }
    }

    #endregion
    #region 패스 높이 - PathHeight

    /// <summary>
    /// 패스 높이
    /// </summary>
    public double PathHeight
    {
        get
        {
            return (double)GetValue(PathHeightProperty);
        }
        set
        {
            SetValue(PathHeightProperty, value);
        }
    }

    #endregion
    #region 패스 데이터 - PathData

    /// <summary>
    /// 패스 데이터
    /// </summary>
    public Geometry PathData
    {
        get
        {
            return (Geometry)GetValue(PathDataProperty);
        }
        set
        {
            SetValue(PathDataProperty, value);
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - PathIconButton()

    /// <summary>
    /// 생성자
    /// </summary>
    public PathIconButton()
    {
        InitializeComponent();
    }

    #endregion
}